# $Id$

use ExtUtils::MakeMaker;

# XXX XS attribute doesn't work
open XS, '>utent.xs' or die "Can't create utent.xs: $!";

WriteMakefile(
    NAME		=> 'User::utent',

    # On my SVR4-derived system I have to link against -lc in order to
    # resolve getutent() and others.  I presume this is because
    # libperl.so doesn't reference these functions.  I don't know what's
    # really going on, or if this will hurt other systems.  Let me know
    # if it does and I'll write a configure test.
    LIBS		=> '-lc',

    VERSION_FROM	=> 'utent.pm',
    # XXX
    #XS			=> { 'utent.xs' => 'utent.c' },
    XSPROTOARG		=> '-noprototypes',
    dist		=> {
    	COMPRESS => 'gzip --best',
    	PREOP	=> '$(MAKE) configure stamp-h.in',
    	SUFFIX	=> 'gz',
    },
    clean		=> {
    	FILES	=> 'config.cache config.h config.log '
		    . 'config.status stamp-h utent.xs'
    },
);

# XXX
unlink 'utent.xs' or die "Error unlinking utent.xs: $!";

sub MY::postamble {
    <<'EOF'
utent.o: config.h

# This really depends on config.cache.  How do you tell make that
# running configure updates both config.cache and config.status?
utent.xs: xs make-xs config.status
	(cat xs; $(PERL) make-xs) > $@

# XXX rebuilding configure runs this, too.  Use a double colon rule?
config.h: stamp-h
stamp-h: config.h.in config.status
	./config.status
	echo timestamp > $@

# XXX Struct member defines are not getting into the generated config.h.in.
###config.h.in: stamp-h.in
###stamp-h.in: configure.in acconfig.h
###	autoheader
###	echo timestamp > $@

# I couldn't find a better way to do this, but there ought to be one.
real_cflags = $(INC) $(CCFLAGS) $(OPTIMIZE) $(PERLTYPE) $(LARGE) \
		$(SPLIT) $(DEFINE_VERSION) $(XS_DEFINE_VERSION)

config.status: configure
	CC="$(CC)" CFLAGS="$(real_cflags)" magic_makemaker_token=t \
	    ./configure $(CONFIGURE_FLAGS)

configure: configure.in aclocal.m4
	autoconf
EOF
}
